<?php
/*
Plugin Name: translit it!
Plugin URI: http://wordpress.org/extend/plugins/translit-it/
Description: Осторожно, это БЕТА версия! Переводим или транслитерализируем адреса страниц. Используется для перевода ЧПУ с русского на английский язык.
Version: 1.2
Author: Ichi-nya
Author URI: http://profiles.wordpress.org/ichi-nya
License: GPL2
Copyright: 2013
*/

$talk = array(
    "№" => "#", "є" => "eh",
    "а" => "a", "б" => "b", "в" => "v", "г" => "g", "д" => "d",
    "е" => "e", "ё" => "e", "ж" => "j",
    "з" => "z", "и" => "i", "й" => "y", "к" => "k", "л" => "l",
    "м" => "m", "н" => "n", "о" => "o", "п" => "p", "р" => "r",
    "с" => "s", "т" => "t", "у" => "u", "ф" => "f", "х" => "h",
    "ц" => "c", "ч" => "ch", "ш" => "sh", "щ" => "sch", "ъ" => "",
    "ы" => "y", "ь" => "", "э" => "e", "ю" => "yu", "я" => "ya",
    "—" => "-", "«" => "", "»" => "", "…" => "", "№" => "#"
);

$iso = array(
    "а" => "a", "б" => "b", "в" => "v", "г" => "g", "д" => "d",
    "е" => "e", "ё" => "yo", "ж" => "zh",
    "з" => "z", "и" => "i", "й" => "j", "к" => "k", "л" => "l",
    "м" => "m", "н" => "n", "о" => "o", "п" => "p", "р" => "r",
    "с" => "s", "т" => "t", "у" => "u", "ф" => "f", "х" => "x",
    "ц" => "c", "ч" => "ch", "ш" => "sh", "щ" => "shh", "ъ" => "",
    "ы" => "y", "ь" => "", "э" => "e", "ю" => "yu", "я" => "ya",
    "—" => "-", "«" => "", "»" => "", "…" => "", "№" => "#"
);

$try_translate = false;

/*
  Обрабатываем выбор
 */

/* Стандартная функция strtolower странно работает, пришлось доделать 
 * (взять подобную из инета и модифицировал для своих нужд
 */

function str2lower($inputString) {
    $outputString = mb_strtolower($inputString, 'UTF-8');
    return $outputString;
}

function try_transtlate($title) {
    global $try_translate, $talk;
    // Была попытка перевода
    $try_translate = true;
    // Используем транслитерацию $iso
    $title_low = str2lower($title);
    $result = strtr($title_low, $talk);
    return $result;
}

function sanitize_title_with_translit($title) {
    global $talk, $iso, $rtl_standard, $rtl_translate;
    $rtl_standard = get_option('rtl_standard');
    $rtl_translate = get_option('rtl_translate');
    switch ($rtl_standard) {
        case 'talk': return strtr(str2lower($title), $talk);
            break;
        case 'iso': return strtr(str2lower($title), $iso);
            break;
        case 'google': return google_sanitize_title($title);
            break;
        case 'yandex': return yandex_sanitize_title($title);
            break;
        case 'yandex2': return yandex_sanitize_title2($title);
            break;
        default: return $title;
            break;
    }
}

function google_sanitize_title($title) {
    global $talk, $try_translate;
    /* $rtl_standard = get_option('rtl_standard');
      $url = 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q='. urlencode($title) .'&langpair=ru%7Cen';
      $translate = file_get_contents($url);
      $json = json_decode($translate, true);
      if (isset($_POST['rtl_standard'])) {$rtl_standard=true;};
      if ($json['responseStatus'] != 200)
      return $title;
      elseif ($rtl_translate and not($try_translate))
      {$try_translate = true; yandex_sanitize_title($title) ;}
      else sanitize_title_with_translit_again($title);

      $result = $json['responseData']['translatedText'];
      $result = htmlspecialchars_decode($result);
      $result = stripslashes($result);
      $result = preg_replace("~\W~", '-', $result);
      $result = preg_replace('~-+~', '-', $result);
      $result = trim($result, '-');
      $result = strtolower($result);
     */
    // Заглушка
    if ($try_translate) {
        $result = strtr(str2lower($title), $talk);
    } else {
        $try_translate = true;
        yandex_sanitize_title($title);
    }
    return $result;
}

function yandex_sanitize_title($title) {
    global $talk, $try_translate, $rtl_translate;
    $status = 200;
    // Для Яндекс API 1.0 УСТАРЕЛО
    //$url = 'http://translate.yandex.net/api/v1/tr.json/translate?lang=ru-en&text=' . urlencode($title);
    // Для Яндекс API 1.5
    $ya_api_15 = get_option('ya_api_key');
    // Проверяем, введен ли API ключ от Яндекса
    if ($ya_api_15 == '') {
        return try_transtlate($title);
    }
    $url = 'https://translate.yandex.net/api/v1.5/tr.json/translate?key=' .
            $ya_api_15 . '&lang=ru-en&text=' .
            urlencode($title);
    // Индийская магия... Убираем лишние обращения к переводчику из-за ограничений
    $title2 = get_the_title();
    if ($title == $title2) {
        $translate = @file_get_contents($url);
        // Если не получается зайти по адресу переводчика
        $status = substr($http_response_header[0], 9, 3);
    } else {
        return try_transtlate($title);
    };
    // Если получить данные от переводчика Яндекса не получилось.
    if ($status != 200) {
        return try_transtlate($title);
    }
    $json = json_decode($translate, true);
    // Проверяем на ошибки получения ответа
    if ($json['code'] == !200) {
        //При ошибке пытаемся перевести через гугл
        if ($try_translate) {
            //Запоминаем, что пытались перевести через Яндекс
            $result = strtr(str2lower($title), $talk);
        } else {
            $try_translate = true;
            google_sanitize_title($title);
        }
    } else {
        // Выбираем результат перевода
        $result = $json['text']['0'];
    };
    if ($rtl_translate) {
        $result = strtr(str2lower($result), $talk);
    }
    return $result;
}

function yandex_sanitize_title2($title) {
    // ЭКСПЕРЕМЕНТАЛЬНАЯ НАСТРОЙКА
    // Перевод через Яндекс в обход API
    global $talk, $try_translate, $iso;
    $status = 200;
    $url = 'http://translate.yandex.net/tr.json/translate?lang=ru-en&text=' .
            urlencode($title) . '&srv=tr-text';
    $translate = @file_get_contents($url);
    // Если не получается зайти по адресу переводчика
    $status = substr($http_response_header[0], 9, 3);
    // Проверяем статус обращения
    if ($status != 200) {
        return try_transtlate($title);
    }
    // Удаляем ковычки
    $text = substr($translate, 1, strlen($translate) - 1);
    return try_transtlate($text);
}

function rtl_options_page() {
    ?>
    <div class="wrap">
        <h2>Настройки Плагина</h2>
        <p>Вы можете выбрать способ, по которому будет производиться транслитерация заголовков.</p>
        <?php
        if ($_POST['rtl_standard']) {
            // set the post formatting options
            update_option('rtl_standard', $_POST['rtl_standard']);
            update_option('rtl_translate', $_POST['rtl_translate']);
            update_option('ya_api_key', $_POST['ya_api_key']);
            echo '<div class="updated"><p>Настройки обновлены.</p></div>';
        }
        ?>

        <form method="post">
            <fieldset class="options">
                <p>Транслитерация происходит только в новых постах</p>
                <legend>Производить транслитерацию способом:</legend>
                <?php
                // Загружаем настройки из базы
                $rtl_standard = get_option('rtl_standard');
                $rtl_translate = get_option('rtl_translate');
                $ya_api_15 = get_option('ya_api_key');
                ?>
                <!-- Choice of the method of transliteration -->
                <select name="rtl_standard">
                    <option value="google"<?php
                    if ($rtl_standard == 'google') {
                        echo(' selected="selected"');
                    }
                    ?>>Google Translate (non work)</option>
                    <option value="yandex"<?php
                    if ($rtl_standard == 'yandex') {
                        echo(' selected="selected"');
                    }
                    ?>>Yandex Translate</option>
                    <option value="yandex2"<?php
                    if ($rtl_standard == 'yandex2') {
                        echo(' selected="selected"');
                    }
                    ?>>Yandex Translate ЭКСПЕРЕМЕНТАЛЬНЫЙ</option>
                    <option value="talk"<?php
                    if ($rtl_standard == 'talk') {
                        echo(' selected="selected"');
                    }
                    ?>>Разговорный</option>
                    <option value="iso"<?php
                    if ($rtl_standard == 'iso') {
                        echo(' selected="selected"');
                    }
                    ?>>ISO 9-95</option>
                    <option value="off"<?php
                    if ($rtl_standard == 'off' OR $rtl_standard == '') {
                        echo(' selected="selected"');
                    }
                    ?>>Отключена</option>
                </select>
                <br />
                <p><input type="checkbox" name="rtl_translate" <?php
                    if ($rtl_translate) {
                        echo 'checked="checked"';
                    }
                    ?>value='1' />Производить транслитерацию после переводчика</p>

                <?php
                if ($rtl_standard == 'google') {
                    echo 'Гугл не работает';
                };
                ?>
                <?php
                if ($rtl_standard == 'yandex') {
                    ?> <label for="ya_api_key">Введите Ваш уникальный API-ключ:</label>
                    <br />
                    <input id="ya_api"
                           type="text"
                           name="ya_api_key"
                           size="150"
                           value="<?php echo $ya_api_15; ?>" />
                    <br />
                    Получить api-ключ Яндекса можно <a href="http://api.yandex.ru/key/form.xml?service=trnsl" target=_blank>тут</a>
                    <?
                };
                ?>
                <br />
                <input type="submit" value="Изменить" />
            </fieldset>
        </form>
    </div>
    <?php
}

// Добавляем опции настроек
function rtl_add_menu() {
    add_options_page('Транслитерируй это!', 'Транслитерируй это!', 8, __FILE__, 'rtl_options_page');
}

add_action('admin_menu', 'rtl_add_menu');
//add_action('sanitize_title', 'sanitize_title_with_translit', 0);
// Меняем названия только вручную
if (!empty($_POST) || !empty($_GET['action']) && $_GET['action'] == 'edit' || defined('XMLRPC_REQUEST') && XMLRPC_REQUEST) {
    add_action('sanitize_title', 'sanitize_title_with_translit', 0);
}
?>